#!/usr/bin/python
# -*- coding: utf-8 -*-

import pylogan.input
import pylogan.process
import pylogan.output

#Need of a configuration file, this variables should be stored there
syslog_path='webroot/syslog'
out_path='webroot/'

#The first step is to read the file (just syslog fromat at the moment).
#There is just one implemented process, and is for squid because I could'nt find a log analyzer for squid capable of use syslog (there is modlogan but is cryptic and discontinued)
input_log=pylogan.input.Squid()
input_log.SourceFile(syslog_path)
lines=input_log.Lines()

#Fill the 'holes' in the timelines
users=pylogan.process.GetUsers(lines)
for user in users.keys():
  users[user]=pylogan.process.CompleteData(users[user])
domains=pylogan.process.TopDomains(lines)
for domain in domains.keys():
  domains[domain]=pylogan.process.CompleteData(domains[domain])
navigations=pylogan.process.TopNavigations(lines)
for navigation in navigations.keys():
  navigations[navigation]=pylogan.process.CompleteData(navigations[navigation])

#Build graphs
users_graph=pylogan.output.RRDTool('users',out_path)
users_graph.GraphTimelines(users,True)
domains_graph=pylogan.output.RRDTool('domains',out_path)
domains_graph.GraphTimelines(pylogan.process.EscapeNames(domains),True)
navigations_graph=pylogan.output.RRDTool('navigations',out_path)
navigations_graph.GraphTimelines(pylogan.process.EscapeNames(navigations),True)

#Build the XHTML page
page=pylogan.output.XHTML(out_path)
page.SetTitle('Utilización del Proxy Squid')
page.CreateBlock('users','Tráfico por Usuarios')
page.IncludeImage('users',users_graph.graphfile)
page.IncludeTable('users',pylogan.process.SumSizes(users))
page.CreateBlock('domains','Tráfico por Dominios')
page.IncludeImage('domains',domains_graph.graphfile)
page.IncludeTable('domains',pylogan.process.SumSizes(domains))
page.CreateBlock('navigations','Tráfico por Navegaciones')
page.IncludeImage('navigations',navigations_graph.graphfile)
page.IncludeTable('navigations',pylogan.process.SumSizes(navigations))
page.BuildContent()
page.WriteFile()

#End
